//======================================================================
//-----------------------------------------------------------------------
// 
// MDIhLgNX(DirectX)t@C
//
//-----------------------------------------------------------------------
//======================================================================
#ifndef _cDoc_H_
#define _cDoc_H_

//======================================================================
// include
#include "iris_using.h"
#include "win/app/WXDXDoc.h"
#include "win/mmsystem/WXMMPfmTimer.h"
#include "d3dx/dxgx.h"
#include "fnd/image/FndEdgeDetector.h"

//======================================================================
// class
class CDoc : public wx::CDXDoc
{
public:
	// C[ID
	typedef enum
	{
		LAYER_TEXTURE,
		LAYER_MODEL,
		LAYER_FONT,
		LAYER_FILTER,
		LAYER_NUM
	} LAYERID;
protected:
	wx::CMMPfmTimer				m_Timer;
	dx::CDXTexture				m_Texture;
	dx::CDXMeshFrame			m_Mesh;
	//CDXMeshSimple			m_Mesh;
	dx::CDXLight				m_Light;
	dx::CDXCamera				m_Camera;
	dx::CDXObjectManager		m_ObjMan;
	dx::CDXFont					m_Font;
	dx::CDXMessageMgr			m_Message;

	CEdgeDetector			m_Edge;
	CEdgeDetector::LAPLACIAN4_KERNEL m_Laplacian;
public:
	// RXgN^
	CDoc(HWND hWnd, LPDOCPARAMS pDocParam);
	// fXgN^
	virtual ~CDoc(void);

public:
	// XV
	virtual void	Transaction(void);
	// Doc`
	virtual void	Draw(void);

public:

	// Cxgnh
	__IrisDocEventFunc(Create);
	__IrisDocEventFunc(Destroy);
};

#endif
