//======================================================================
//-----------------------------------------------------------------------
// 
// Ct@C
//
//-----------------------------------------------------------------------
// @author	t.sirayanagi
//======================================================================
#ifndef _cMain_H_
#define _cMain_H_

//======================================================================
// include
#include "win/app/WXDXMDIApplication.h"
#include "win/control/WXStatusBar.h"
#include "win/control/WXMenu.h"
#include "win/exp/accelerator/WXCustomAccel.h"
#include "fnd/container/FndSingleton.h"
#include "cDoc.h"
#include "d3dx/dxpad.h"
#include "iris_using.h"

//======================================================================
// class
class CMain : public iris::wx::CDXMDIApplication<CDoc>, public iris::fnd::CSingleton<CMain>
{
	typedef iris::wx::CDXMDIApplication<CDoc> CApp;
protected:
	// pFunctor
	typedef struct InitFunctor
	{
		DWORD operator()(CMain* p, void* arg) { return (DWORD)p->OnInitThread(arg); }
	} InitFunctor;

protected:
	wx::CCustomAccel		m_CustomAccel;
	// status bar
	wx::CStatusBar			m_StatusBar;
	// menu
	wx::CMenu				m_Menu1;
	wx::CMenu				m_Menu2;
private:
	// RXgN^
	CMain(void);
	// fXgN^
	virtual ~CMain(void);
public:
	// Instance
	static CMain&	CreateInstance(void)	{ CMain* pInstance = new CMain; return *pInstance; }
	static void		DeleteInstance(void)	{ CMain* pInstance = GetInstancePtr(); IRIS_SAFE_DELETE( pInstance ); }
protected:
	// 
	virtual bool	OnInit(void);
	// iXbhĂяoj
	virtual bool	OnInitThread(void* arg);
	// ֐
	virtual void	Transaction(void);
	// MDIpj[nh̎擾
	virtual HMENU	GetMDIMenuHandle(bool isDoc);
	// MDIEBhEpj[nh̎擾
	virtual HMENU	GetMDIWindowMenuHandle(HMENU hMenu);

protected:
	__IrisAppEventFunc(Command);
	__IrisAppEventFunc(MenuSelect);
	__IrisAppEventFunc(ExitMenuLoop);
	__IrisAppEventFunc(Destroy);
	__IrisAppEventFunc(Size);
};

#endif
