//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		AXAudioBuffer.h
 * @brief		I[fBIobt@ t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_AXAudioBuffer_H_
#define INCG_IRIS_AXAudioBuffer_H_

//======================================================================
// include
#include "AXAudioFile.h"
#include "fnd/memory/FndMemBuffer.h"

namespace iris {
namespace ax
{

//======================================================================
// class
/// I[fBIobt@
class CAXBuffer : public fnd::CMemBuffer
{
protected:
	IAXFile*	m_pFile;	//!< t@CNX
	u32			m_ReadSize;	//!< Ǎ݃TCY
public:
	// RXgN^
	CAXBuffer(void);
	CAXBuffer(IAXFile* pFile);

public:
	/// 
	virtual	void	Initialize(void)	{}

public:
	// f[^̓Ǎ
	virtual	bool	Read(u32 uSize);
	virtual	bool	Read(void);

public:
	/// t@C̐ݒ
	void		SetFile(IAXFile* pFile)		{ m_pFile = pFile; }
	/// t@C̎擾
	IAXFile*	GetFile(void)				{ return m_pFile; }
	/// Ǎ݃TCY̎擾
	u32			GetReadSize(void)	const	{ return m_ReadSize; }
};

}	// end of namespace ax
}	// end of namespace iris

#endif
