//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		FndRSA32.h
 * @brief		RSAÍAt@C(32bit)
 * @deprecated	p,q,eɓKł鐔Ȃ̂ŁAp
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_FndRSA32_H_
#define INCG_IRIS_FndRSA32_H_

//======================================================================
// include
#include "../../iris_object.h"

namespace iris {
namespace fnd
{

//======================================================================
// class
//! RSAÍNX(32bit)
class CRSA32 : public IIrisObject
{
	// private key
	u32	m_p, m_q, m_d;
protected:
	u32	m_e;	//!< public key (encrypt key)
	u32	m_n;	//!< public key (valid space)
public:
	/// RXgN^
	CRSA32(void);
	/// fXgN^
	//~CRSA32(void);

public:
	// 
	bool	Init(u32 p, u32 q, u32 e);

	// Í
	u32		Encrypt(u32 m);
	// 
	u32		Decrypt(u32 c);

public:
	// ̎擾
	u32		GetPublicKeyN(void)	const	{ return m_n; }
	u32		GetPublicKeyE(void)	const	{ return m_e; }

};

}	// end of namespace fnd
}	// end of namespace iris

#endif
