//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		FndZero.h
 * @brief		Zero `NX t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_FndZero_H_
#define INCG_IRIS_FndZero_H_

//======================================================================
// include
#include "../../iris_object.h"

namespace iris {
namespace fnd
{

//======================================================================
// class
/**
 * @brief	[`NX
 * @tparam _TN	= ^
*/
template<typename _TN>
class CZero : public IIrisObject
{
	typedef _TN	value_type;
public:
	operator value_type (void)	const	{ return get(); }
public:
IRIS_PRAGMA_WARNING_BEGIN()
IRIS_PRAGMA_WARNING_DISABLE(4700)
	static inline value_type	get(void)		
	{
		_TN tmp; return tmp-tmp; 
	}
IRIS_PRAGMA_WARNING_END()
};

}	// end of namespace fnd
}	// end of namespace iris

#endif
