//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		FBXTexture.h
 * @brief		FBX SDK textureNXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_FBXTexture_H_
#define INCG_IRIS_FBXTexture_H_

//======================================================================
// include
#ifdef _IRIS_SUPPORT_FBX
#include "../../../fnd/types/FndExecutor.h"
#include "../FBXAttribute.h"
#endif

#ifdef _IRIS_SUPPORT_FBX

namespace iris {
namespace gx {
namespace fbx
{

//======================================================================
// class
/// FBX SDK Texture
class CFBXTexture : public IFBXAttribute<KFbxTexture>, public fnd::CExecutor
{
public:
	// RXgN^
	CFBXTexture(void);
	// fXgN^
	virtual ~CFBXTexture(void);

public:
	// XV
	virtual	void	Update(xf32 time);
	// `
	virtual	void	Draw(void);
};


}	// end of namespace fbx
}	// end of namespace gx
}	// end of namespace iris

#endif

#endif
