//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		iris_global.h
 * @brief		irisO[ot@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_iris_global_H_
#define INCG_IRIS_iris_global_H_

//======================================================================
// include
#include "iris_inchead.h"

EXTERN_C_BEGIN

//======================================================================
// struct
//! n[hEFA^[Qbgʎq
typedef enum HDW_TARGET_ID
{
	TARGET_WIN32		= IRIS_FOURCC('W', 'X', '3', '2'),	//!< win32
	TARGET_WINCONSOLE	= IRIS_FOURCC('W', 'X', 'C', 'O'),	//!< win console
	TARGET_WINDLL		= IRIS_FOURCC('W', 'X', 'D', 'L'),	//!< win dll
	TARGET_IPHONE		= IRIS_FOURCC('I', 'P', 'H', 'N'),	//!< iPhone
	TARGET_MAC			= IRIS_FOURCC('M', 'A', 'C', 'X'),	//!< Mac
	TARGET_STM32		= IRIS_FOURCC('S', 'T', '3', '2'),	//!< STM32
	TARGET_UNKNOWN		= IRIS_FOURCC('U', 'N', 'K', 'W')	//!< nuknown0
} HDW_TARGET_ID;
//! Ñp[^
typedef struct IrisEntryInfo
{
	IrisS32		uTarget;	//!< ^[Qbgʎq
#if defined(_WIN32)

#if		defined(_CONSOLE)
#elif	defined(_USRDLL)
	HINSTANCE	hInstance;
	DWORD		dwReason;
	LPVOID		lpReserved;
#else
	HINSTANCE	hInstance;
	HINSTANCE	hPrevInstance;
	LPTSTR		lpCmdLine;
	int			nShowCmd;
#endif

#else

#endif
} IrisEntryInfo, *LPIrisEntryInfo;

//======================================================================
// variable
extern IrisEntryInfo	__g_EntryInfo;

//======================================================================
// function
// Gg[̎擾
LPIrisEntryInfo	irisGetEntryInfo(void);

// ^[Qbgʎq̎擾
IrisS32			irisGetHardWareTargetID(void);

// ̐擾
int				irisGetArgc(void);
// ̕擾
char*			irisGetArgvN(int n);
// ̕擾
char**			irisGetArgv(void);

EXTERN_C_END

#endif
