//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		MathCommonMulDiv.h
 * @brief		{E񐔃t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_MathCommonMulDiv_H_
#define INCG_IRIS_MathCommonMulDiv_H_

//======================================================================
// include
#include "../iris_math.h"

namespace iris {
namespace math
{

//======================================================================
// function

/**********************************************************************//**
 * @brief ő
*//***********************************************************************/
template<typename _Type>
_Type	gcd(_Type a, _Type b)
{
	// [Nbȟݏ@
	if( a == (_Type)0 || b == (_Type)0 ) return 0;
#if 0
	// ZȂ
	while( a != b )
	{
		(a > b) ? (a = a - b) : (b = b - a);
	}
	return a;
#else
	_Type m = a;
	_Type n = b;
	if( m < n ) { m = b; n = a; }
	while( n != (_Type)0 )	
	{
		_Type t = m%n;
		m = n;
		n = t;
	}
	return m;
#endif
}

/**********************************************************************//**
 * @brief ŏ{
*//***********************************************************************/
template<typename _Type>
_Type	lcm(_Type a, _Type b)
{
	// gcd(a,b)*lcm(a,b) == ab
	_Type _gcd = gcd(a,b);
	return (a*b)/_gcd;
}

}	// end of namespace math
}	// end of namespace iris

#endif
