//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		HvkBoxShape.h
 * @brief		Havok BoxShape t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_HvkBoxShape_H_
#define INCG_IRIS_HvkBoxShape_H_

//======================================================================
// include
#include "HvkShape.h"

#ifdef _IRIS_SUPPORT_HAVOK
#include "Physics/Collide/Shape/Convex/Box/hkpBoxShape.h"

namespace iris {
namespace havok
{

//======================================================================
// class
/// Shape NXC^[tFCX
class CBoxShape : public IShape
{
public:
	// RXgN^
	CBoxShape(void);
	// fXgN^
	virtual ~CBoxShape(void);

public:
	// 쐬
	bool	Create(hkReal x, hkReal y, hkReal z);
	bool	Create(const hkVector4& halfExtents);
};


}	// end of namespace havok
}	// end of namespace iris

#endif

#endif
