//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		HvkCapsuleShape.h
 * @brief		Havok CapsuleShape t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_HvkCapsuleShape_H_
#define INCG_IRIS_HvkCapsuleShape_H_

//======================================================================
// include
#include "HvkShape.h"

#ifdef _IRIS_SUPPORT_HAVOK
#include "Physics/Collide/Shape/Convex/Capsule/hkpCapsuleShape.h"

namespace iris {
namespace havok
{

//======================================================================
// class
/// Shape NXC^[tFCX
class CCapsuleShape : public IShape
{
public:
	// RXgN^
	CCapsuleShape(void);
	// fXgN^
	virtual ~CCapsuleShape(void);

public:
	// 쐬
	bool	Create(const hkVector4& vertexA,const hkVector4& vertexB, hkReal radius);
};


}	// end of namespace havok
}	// end of namespace iris

#endif

#endif
