//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXSHChooseFont.h
 * @brief		tHgI_CAONX t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_WXSHChooseFont_H_
#define INCG_IRIS_WXSHChooseFont_H_

//======================================================================
// include
#include "iris_object.h"
#include <commdlg.h>

namespace iris {
namespace wx
{

//======================================================================
// class
/**
 * @brief	tHgI_CAONX
*/
class CSHChooseFont : public IIrisObject
{
private:

public:
	// J
	static	BOOL	ShowA(HWND hOwner, LPLOGFONTA lpLogFont, int SizeMin, int SizeMax, DWORD Flags, LPCOLORREF pColor=nullptr, LPINT lpPointSize=nullptr
						  , LPCSTR  lpTemplateName=nullptr, HINSTANCE hInstance=nullptr, LPCCHOOKPROC lpfnHook=nullptr, LPARAM lCustData=0);
	static	BOOL	ShowW(HWND hOwner, LPLOGFONTW lpLogFont, int SizeMin, int SizeMax, DWORD Flags, LPCOLORREF pColor=nullptr, LPINT lpPointSize=nullptr
						  , LPCWSTR lpTemplateName=nullptr, HINSTANCE hInstance=nullptr, LPCCHOOKPROC lpfnHook=nullptr, LPARAM lCustData=0);

	/**
	 * @name	J
	 * @{
	*/
	static	BOOL	Show(HWND hOwner, LPLOGFONTA lpLogFont, int SizeMin, int SizeMax, DWORD Flags, LPCOLORREF pColor=nullptr, LPINT lpPointSize=nullptr
						  , LPCSTR  lpTemplateName=nullptr, HINSTANCE hInstance=nullptr, LPCCHOOKPROC lpfnHook=nullptr, LPARAM lCustData=0)	
	{ return ShowA(hOwner, lpLogFont, SizeMin, SizeMax, Flags, pColor, lpPointSize, lpTemplateName, hInstance, lpfnHook, lCustData); }

	static	BOOL	Show(HWND hOwner, LPLOGFONTW lpLogFont, int SizeMin, int SizeMax, DWORD Flags, LPCOLORREF pColor=nullptr, LPINT lpPointSize=nullptr
						  , LPCWSTR lpTemplateName=nullptr, HINSTANCE hInstance=nullptr, LPCCHOOKPROC lpfnHook=nullptr, LPARAM lCustData=0)	
	{ return ShowW(hOwner, lpLogFont, SizeMin, SizeMax, Flags, pColor, lpPointSize, lpTemplateName, hInstance, lpfnHook, lCustData); }
	/**
	 * @}
	*/
};

}	// end of namespace wx
}	// end of namespace iris

#endif
