//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		UnitClass.cpp
 * @brief		Unit Class t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define INCG_IRIS_UnitClass_CPP_

//======================================================================
// include
#include "UnitClass.h"

#if (defined(_IRIS_UNITTEST) || defined(_IRIS_MULTI_UNITTEST) )

namespace iris {
namespace unit
{

namespace 
{
	static CUnitTestBase*	s_pCurrent = nullptr;
}

//======================================================================
// class
/**********************************************************************//**
 *
 * s
 *
*//***********************************************************************/
void CUnitTestBase::Exec(PFN_UnitTestMain pMain)
{
	s_pCurrent = this;
	pMain();
	s_pCurrent = nullptr;
}

/**********************************************************************//**
 *
 * I
 *
*//***********************************************************************/
void CUnitTestBase::Abort(void)
{
	OnAbort();
}

/**********************************************************************//**
 *
 * JgeXgNX̎擾
 *
*//***********************************************************************/
CUnitTestBase* CUnitTestBase::GetCurrent(void)
{
	return s_pCurrent;
}

}	// end of namespace unit
}	// end of namespace iris

#endif
